var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { PureComponent } from 'react';
import { Icon } from '../icon';
var Alert = /** @class */ (function (_super) {
    __extends(Alert, _super);
    function Alert() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            showContent: !!_this.props.defaultShow
        };
        _this.toggleContent = function () {
            _this.setState(function (_a) {
                var showContent = _a.showContent;
                return ({
                    showContent: !showContent
                });
            });
        };
        return _this;
    }
    Alert.prototype.render = function () {
        var _a = this.props, title = _a.title, text = _a.text, _b = _a.texts, texts = _b === void 0 ? [] : _b, type = _a.type, needToolTip = _a.needToolTip, defaultShow = _a.defaultShow, collapse = _a.collapse, other = __rest(_a, ["title", "text", "texts", "type", "needToolTip", "defaultShow", "collapse"]);
        var showContent = this.state.showContent;
        var titleDOM = title && (React.createElement("h4", { className: "title" },
            React.createElement("div", { onClick: collapse ? this.toggleContent : undefined },
                title,
                collapse && (React.createElement(Icon, { n: showContent ? "arrow-up" : "arrow-down" })))));
        var textDOM = text && (React.createElement("div", { className: "item" }, text));
        var textsDOM = [];
        for (var i = 0; i < texts.length; i++) {
            var currT = texts[i];
            if (currT) {
                textsDOM.push(React.createElement("div", { className: "item", key: i }, i + 1 + ".",
                    " ",
                    currT));
            }
        }
        return (React.createElement("div", __assign({ className: "__alert " + type }, other),
            titleDOM,
            showContent ? (React.createElement(React.Fragment, null,
                textDOM,
                textsDOM)) : null));
    };
    Alert.defaultProps = {
        type: 'normal',
        needToolTip: false,
        defaultShow: true,
        collapse: false,
        title: '',
        text: '',
    };
    return Alert;
}(PureComponent));
export default Alert;
