/// <reference types="react" />
import { UkePureComponent } from '../utils/uke-component';
import { Color } from '../utils/props';
export interface AvatarProps {
    /** 头像的大小 */
    color?: Color;
    /** 头像的大小 */
    size?: number;
    /** Avatar 中显示的字 */
    text?: string;
    /** 头像的数组, ['A', 'B', 'face.jpg'] */
    faceOptions?: string[];
    /** 是否可换头像 */
    changeAvatarable?: boolean;
    /** 图片地址, 可以为网络图片、base64 和相对路径图片 */
    src?: string;
    /** 弹出的位置 */
    position?: string;
    /** icon 名称，参考 Icon */
    icon?: string;
    /** className */
    className?: string;
    /** 显示在右上角的提示 */
    tip?: boolean | string | number;
    /** 换头像后的回调 */
    onChangeAvatar?: (avatarRes: any) => void;
}
/**
 * Avatar
 *
 * @export
 * @class Avatar
 * @extends {PureComponent}
 */
export default class Avatar extends UkePureComponent<AvatarProps> {
    static defaultProps: AvatarProps;
    constructor(props: any);
    changeAvatar: (res: any) => void;
    renderMoreOptions: ({ hide }: {
        hide: any;
    }) => JSX.Element;
    render(): JSX.Element;
}
