/// <reference types="react" />
import { DateBasic, DateBasicProps } from '../date-basic';
import { PopoverEntity } from '../popover/popover-entity';
export interface DatetimePickerProps extends DateBasicProps {
    /** 默认的时分秒的值 */
    defaultTimes?: string[];
    /** 日期控件类型 */
    mode?: "single" | "multiple" | "range" | "time";
    /** 是否允许用户输入 */
    allowInput?: boolean;
    /** 语言 */
    lang?: string;
    /** didMount */
    didMount?: () => void;
    /** 默认值 */
    defaultValue?: string[];
}
/**
 * 基于 Flatpickr 的时间控件，样式可以根据喜好选择
 *
 * @export
 * @class DatetimePicker
 * @extends {DateBasic}
 */
export default class DatetimePicker extends DateBasic<DatetimePickerProps> {
    static setCDNUrl: (url: any) => void;
    static defaultProps: {
        needTime: boolean;
        toUTC: boolean;
        allowInput: boolean;
        outputAsString: boolean;
        mode: string;
        lang: string;
        defaultTimes: string[];
    };
    _refs: {};
    datepicker: any;
    isControl: boolean;
    value: any;
    popTipEntity: PopoverEntity;
    _id: string;
    constructor(props: any);
    componentDidMount(): void;
    setDate: (nextValue: any, tiggerChange?: boolean) => void;
    componentWillUnmount(): void;
    handleInputError: (inputElem: any, isError: any) => void;
    getInputValAsync: () => Promise<Date[] | null>;
    getDateRangeFromInput: () => Date[] | null;
    handleChange: (rangeValues: any, dateStr: any, instance: any) => Promise<void>;
    initPicker: () => void;
    changeDate: (val: any) => void;
    render(): JSX.Element;
}
