import React from 'react';
import InputVerifyClass, { InputVerifyClassProps } from './input-verify-class';
export interface InputVerifyProps extends InputVerifyClassProps {
    /** 控件类型 */
    type?: 'input' | 'password';
    /** 是否开启数字转中文 */
    needCN?: boolean;
    /** 是否显示百分比 */
    precent?: boolean;
    /** 是否可输入 */
    inputable?: boolean;
    /** 是否启动操作按钮 */
    selectable?: boolean;
    /** 辅助按钮每一次的增减单位 */
    unit?: number;
    /** style */
    style?: React.CSSProperties;
}
/**
 * 继承于 InputVerifyClass 的模版
 *
 * @export
 * @class InputNumber
 * @extends {InputVerifyClass}
 */
export default class InputNumber extends InputVerifyClass<InputVerifyProps> {
    render(): JSX.Element;
}
