/// <reference types="react" />
import FormFilterHelper, { FormFilterProps, FormOptionsItem } from './form-filter';
export declare type ConditionOptions = FormOptionsItem[];
export interface ConditionGeneratorProps extends FormFilterProps {
    /** 查询条件的配置 */
    conditionConfig: ConditionOptions;
    /** className */
    className?: string;
    /** onSubmit */
    onSubmit?: (values: any) => void;
}
/**
 * 查询条件生成器
 *
 * @export
 * @class ConditionGenerator
 * @extends {FormFilterHelper}
 */
export default class ConditionGenerator extends FormFilterHelper<ConditionGeneratorProps> {
    static defaultProps: {
        className: string;
    };
    titleDisplayFilter: (config: any) => any;
    render(): JSX.Element;
}
