var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
/* eslint-disable no-prototype-builtins */
/* eslint-disable no-param-reassign */
/* eslint-disable prefer-destructuring */
/* eslint-disable guard-for-in */
import React from 'react';
import { Call, CallFunc, IsFunc, HasValue, IsObj } from 'basic-helper';
import { UkeComponent } from '../utils/uke-component';
import { DatetimePicker } from '../datetimepicker';
import { DateShortcut } from '../date-shortcut';
import { Radio, DropdownMenu, Checkbox } from '../selector';
import { Input } from '../form-control';
import { Ranger } from '../range-selector';
import { Captcha } from '../captcha';
import { ToolTip } from '../tooltip';
import InputSelector from '../form-control/input-selector';
import Switch from '../switch-button/switch-c';
var wrapInputSelectorMarkForRefu = function (activeRef) { return "__isActive" + activeRef; };
/**
 * 表单生成器
 * 统一的聚合表单
 */
var FormFilterHelper = /** @class */ (function (_super) {
    __extends(FormFilterHelper, _super);
    function FormFilterHelper(props) {
        var _this = _super.call(this, props) || this;
        _this._refs = {};
        _this.state = {};
        _this.value = {};
        // 用于检测是否通过表单强制要求验证的mapper
        _this.requiredRefMapper = {};
        _this.__mount = false;
        _this.clearValue = function () {
            _this.setState(function () {
                _this.value = {};
                _this.requiredRefMapper = {};
                return {
                    value: {}
                };
            });
        };
        _this._requiredMapperSetter = function (ref, title) {
            var _a;
            _this.requiredRefMapper = __assign(__assign({}, _this.requiredRefMapper), (_a = {}, _a[ref] = title, _a));
        };
        _this.zeroFilter = function (target, otherwise) { return (target === 0 ? 0 : (target || otherwise)); };
        _this.saveRef = function (ref) { return function (elem) { _this._refs[ref] = elem; }; };
        _this.getRef = function (ref) { return _this._refs[ref]; };
        _this.loadPlugin = function (Plugin, props) {
            var P = IsFunc(Plugin) ? React.createElement(Plugin, null) : Plugin;
            P = React.cloneElement(P, props);
            return P;
        };
        /** 获取 refs 的 ID */
        _this.getRefsID = function (refs) { return (Array.isArray(refs) ? refs.join('-') : ''); };
        /**
         * 表单插件接口
         *
         * @param {object} config 配置项
         * @memberof FormFilterHelper
         */
        _this.getCustomForm = function (config) {
            var ref = config.ref, getCustomFormControl = config.getCustomFormControl, other = __rest(config, ["ref", "getCustomFormControl"]);
            var customeComponent = IsFunc(getCustomFormControl) ? getCustomFormControl() : null;
            if (!customeComponent)
                return null;
            var component = customeComponent.component || customeComponent;
            var cusProps = customeComponent.props || {};
            return _this.loadPlugin(component, __assign(__assign(__assign({}, other), cusProps), { onChange: function (val) { return _this.changeValue(val, ref); } }));
        };
        _this.getCaptcha = function (config) {
            var ref = config.ref, _a = config.keyRef, keyRef = _a === void 0 ? 'CaptchaKey' : _a, other = __rest(config, ["ref", "keyRef"]);
            return (React.createElement(Captcha, __assign({}, other, { value: _this.getValue(ref, ''), ref: _this.saveRef('CaptchaCode'), onCaptchaLoad: function (captchKey) { return _this.changeValue(captchKey, keyRef); }, onChange: function (captchaConfig) {
                    _this.changeValue(captchaConfig.value, ref);
                } })));
        };
        _this.getSelectNative = function (config) {
            var values = config.values, ref = config.ref;
            return (React.createElement("select", { className: "form-control", ref: _this.saveRef(ref), value: _this.getValue(ref), onChange: function (e) {
                    _this.changeValue(e.target.value, ref);
                } }, Object.keys(values).map(function (val, idx) { return (React.createElement("option", { key: val, value: val }, values[val])); })));
        };
        _this.getSelect = function (config) {
            var ref = config.ref, other = __rest(config, ["ref"]);
            return (React.createElement(DropdownMenu, __assign({}, other, { ref: _this.saveRef(ref), value: _this.getValue(ref), onChange: function (val) {
                    _this.changeValue(val, ref);
                } })));
        };
        _this.getInputSelectorS = function (config) {
            var _a = config.inputProps, inputProps = _a === void 0 ? {} : _a, defaultValueForS = config.defaultValueForS, refForS = config.refForS, values = config.values, required = config.required, ref = config.ref, other = __rest(config, ["inputProps", "defaultValueForS", "refForS", "values", "required", "ref"]);
            return (React.createElement(InputSelector, __assign({}, other, { ref: _this.saveRef(ref), defaultSelectorIdx: defaultValueForS, values: values, inputProps: inputProps, value: _this.zeroFilter(_this.getValue(ref), ''), onChange: function (val, activeRef) {
                    var _a;
                    var isEmptyVal = val == '';
                    _this.changeValues((_a = {},
                        _a[ref] = isEmptyVal ? undefined : val,
                        _a[refForS] = isEmptyVal ? undefined : activeRef,
                        _a));
                } })));
        };
        _this.getInputSelector = function (config) {
            var _a = config.inputProps, inputProps = _a === void 0 ? {} : _a, defaultValueForS = config.defaultValueForS, refu = config.refu, required = config.required, other = __rest(config, ["inputProps", "defaultValueForS", "refu", "required"]);
            return (React.createElement(InputSelector, __assign({}, other, { ref: function (e) {
                    for (var _ref in refu) {
                        if (refu.hasOwnProperty(_ref)) {
                            _this.saveRef(_ref)(e);
                        }
                    }
                }, defaultSelectorIdx: defaultValueForS, values: refu, inputProps: inputProps, 
                // value={this.zeroFilter(this.getValue(this[activeMark]), '')}
                onChange: function (val, activeRef) {
                    if (!_this.value.hasOwnProperty(activeRef)) {
                        Object.keys(refu).map(function (itemRef) {
                            var activeMark = wrapInputSelectorMarkForRefu(activeRef);
                            /** selector 改变时，需要把其余的清空，确保输出只有一个 */
                            _this[activeMark] = activeRef === itemRef;
                            if (!_this[activeMark]) {
                                delete _this.value[itemRef];
                                delete _this.requiredRefMapper[itemRef];
                            }
                            else if (required) {
                                _this.requiredRefMapper[activeRef] = config.title;
                            }
                        });
                    }
                    _this.changeValue(val, activeRef);
                } })));
        };
        _this.getInputRange = function (config) {
            /** 中间无用的是用于过滤 other */
            var refs = config.refs, formClass = config.formClass, type = config.type, title = config.title, _title = config._title, other = __rest(config, ["refs", "formClass", "type", "title", "_title"]);
            var refS = refs[0], refE = refs[1];
            return (React.createElement("div", { className: "input-range" },
                _this.getInput(__assign({ ref: refS, _title: _this.$T_UKE('起') }, other)),
                React.createElement("span", null, " - "),
                _this.getInput(__assign({ ref: refE, _title: _this.$T_UKE('止') }, other))));
        };
        _this.getInput = function (config) {
            var ref = config.ref, className = config.className, _title = config._title, props = config.props, other = __rest(config, ["ref", "className", "_title", "props"]);
            var formClass = "form-control " + (className || '');
            return (React.createElement(Input, __assign({}, other, { title: _title, propsForInput: props, ref: _this.saveRef(ref), className: formClass, value: _this.zeroFilter(_this.getValue(ref), ''), onBlur: function (val, e) {
                    /** 在 onBlur 中修正 value 的类型 */
                    _this.changeValue(val, ref);
                    Call(config.onBlur, val);
                }, onChange: function (val) {
                    _this.changeValue(val === '' ? undefined : val, ref);
                } })));
        };
        _this.getTextArea = function (config) {
            var ref = config.ref;
            return (React.createElement("textarea", { value: _this.getValue(ref), className: "form-control", ref: _this.saveRef(ref), id: ref, onChange: function (e) { return _this.changeValue(e.target.value, ref); } }));
        };
        _this.getRange = function (config) {
            var ref = config.ref, other = __rest(config, ["ref"]);
            return (React.createElement(Ranger, __assign({}, other, { ref: _this.saveRef(ref), value: _this.getValue(ref), onChange: function (val) { return _this.changeValue(val, ref); } })));
        };
        _this.getText = function (config) {
            var ref = config.ref, highlight = config.highlight, value = config.value, text = config.text;
            return (React.createElement("span", { className: highlight ? 'highlight' : '' }, _this.getValue(ref, value || text)));
        };
        _this.radioFactory = function (Comp) { return function (config) {
            var ref = config.ref, refs = config.refs, other = __rest(config, ["ref", "refs"]);
            return (React.createElement(Comp, __assign({}, other, { ref: _this.saveRef(ref), value: _this.zeroFilter(_this.value[ref]), onChange: function (val) {
                    _this.changeValue(val, ref);
                } })));
        }; };
        _this.getRadio = _this.radioFactory(Radio);
        _this.getCheckbox = _this.radioFactory(Checkbox);
        _this.getButton = function (config) {
            var ref = config.ref, className = config.className, text = config.text, onClick = config.onClick;
            return (React.createElement("span", { className: "btn flat " + className, ref: _this.saveRef(ref), onClick: function (e) { return Call(onClick, e, ref); } }, text));
        };
        _this.getDatetime = function (config) {
            var ref = config.ref, _a = config.needTime, needTime = _a === void 0 ? true : _a, other = __rest(config, ["ref", "needTime"]);
            return (React.createElement(DatetimePicker, __assign({}, other, { needTime: needTime, id: ref, value: _this.getValue(ref), onChange: function (val) {
                    _this.changeValue(val, ref);
                } })));
        };
        _this.changeDateRangeValues = function (vals, refs) {
            var _a;
            var refS = refs[0], refE = refs[1];
            // const datetimeRangeRef = getRefsID(refs);
            if (!Array.isArray(vals)) {
                // 如果不是数组，则封装成数组
                vals = [vals];
            }
            // if (vals.length === 0) {
            //   // 如果是 []，则清空值
            //   this.value[datetimeRangeRef] = null;
            // } else {
            //   this.value[datetimeRangeRef] = vals;
            // }
            var nextValue = (_a = {},
                _a[refS] = vals[0],
                _a[refE] = vals[1] || vals[0],
                _a);
            // this.value[datetimeRangeRef] = vals;
            _this.changeValues(nextValue);
        };
        // changeDateRangeValues = (vals, refs) => {
        //   const [refS, refE] = refs;
        //   const datetimeRangeRef = this.getRefsID(refs);
        //   if (vals.length === 0) {
        //     this.value[datetimeRangeRef] = null;
        //   } else {
        //     this.value[datetimeRangeRef] = vals;
        //   }
        //   const nextValue = {
        //     [refS]: vals[0],
        //     [refE]: vals[1],
        //     // [datetimeRangeRef]: [...vals]
        //   };
        //   this.value[datetimeRangeRef] = vals;
        //   this.changeValues(nextValue);
        // }
        _this.getDatetimeRange = function (config) {
            var ref = config.ref, range = config.range, mode = config.mode, refs = config.refs, other = __rest(config, ["ref", "range", "mode", "refs"]);
            // let [refS, refE] = refs;
            var datetimeRangeRef = _this.getRefsID(refs);
            return (React.createElement("div", { className: "datepicker-ranger-content" },
                React.createElement(DatetimePicker, __assign({ mode: "range" }, other, { ref: _this.saveRef(datetimeRangeRef), id: datetimeRangeRef, defaultValue: range, 
                    // value={this.value[datetimeRangeRef]}
                    onChange: function (val) {
                        _this.changeDateRangeValues(val, refs);
                    } })),
                !config.noHelper && (React.createElement(DateShortcut, __assign({}, other, { position: "right", onChange: function (val) {
                        // 点击更改 DatetimePicker 中的值
                        _this.getRef(datetimeRangeRef).setDate(val);
                        // this.changeDateRangeValues(val, refs);
                    } })))));
        };
        _this.getSwitch = function (config) {
            var ref = config.ref, defaultValue = config.defaultValue, other = __rest(config, ["ref", "defaultValue"]);
            return (React.createElement(Switch, __assign({ ref: _this.saveRef(ref) }, other, { checked: _this.getValue(ref), defaultChecked: defaultValue, onChange: function (val) { return _this.changeValue(val, ref); } })));
        };
        _this.getHr = function () { return React.createElement("hr", null); };
        _this.typeMapper = {
            customForm: _this.getCustomForm,
            captcha: _this.getCaptcha,
            'select-n': _this.getSelectNative,
            select: _this.getSelect,
            'input-selector-s': _this.getInputSelectorS,
            'input-selector': _this.getInputSelector,
            'input-range': _this.getInputRange,
            input: _this.getInput,
            password: _this.getInput,
            textarea: _this.getTextArea,
            ranger: _this.getRange,
            text: _this.getText,
            radio: _this.getRadio,
            checkbox: _this.getCheckbox,
            button: _this.getButton,
            datetime: _this.getDatetime,
            datetimeRange: _this.getDatetimeRange,
            switch: _this.getSwitch,
            hr: _this.getHr,
        };
        _this.state = {
            value: {}
        };
        _this.initValues();
        return _this;
    }
    FormFilterHelper.prototype.componentDidMount = function () {
        this.__mount = true;
    };
    FormFilterHelper.prototype.componentWillUnmount = function () {
        this.value = {};
        this.requiredRefMapper = {};
        this.__mount = false;
    };
    FormFilterHelper.prototype.componentDidUpdate = function (prevProps, prevState) {
        this.checkFormOptions(prevProps);
    };
    FormFilterHelper.prototype.initValues = function () {
        var formOptions = this.getFormOptions(this.props);
        this.setDefaultValues(formOptions);
        if (this.__mount)
            this.forceUpdate();
    };
    FormFilterHelper.prototype.resetValues = function (formOptions) {
        if (!formOptions)
            return;
        var nextValue = {};
        for (var i = 0; i < formOptions.length; i++) {
            var options = formOptions[i];
            if (typeof options === 'object') {
                // const val = this.value[valKey];
                var _a = options.ref, ref = _a === void 0 ? '' : _a, refs = options.refs;
                if (this.value[ref])
                    nextValue[ref] = this.value[ref];
                if (Array.isArray(refs)) {
                    var refsID = this.getRefsID(refs);
                    if (this.value[refsID])
                        nextValue[refsID] = this.value[refsID];
                    for (var _i = 0, refs_1 = refs; _i < refs_1.length; _i++) {
                        var itemRef = refs_1[_i];
                        if (this.value[itemRef])
                            nextValue[itemRef] = this.value[itemRef];
                    }
                }
            }
        }
        this.value = nextValue;
        this.initValues();
    };
    FormFilterHelper.prototype.getFormOptions = function (props) {
        if (props === void 0) { props = this.props; }
        return props.formOptions || props.conditionConfig || [];
    };
    FormFilterHelper.prototype.checkFormOptions = function (prevProps) {
        var thisFormOptions = this.getFormOptions(this.props);
        var prevFormOptions = this.getFormOptions(prevProps);
        if (thisFormOptions != prevFormOptions) {
            this.resetValues(thisFormOptions);
            this.resetRequireRefMapper(this.props);
        }
    };
    FormFilterHelper.prototype.resetRequireRefMapper = function (nextProps) {
        if (nextProps === void 0) { nextProps = this.props; }
        this.requiredRefMapper = {};
        var formOptions = this.getFormOptions(nextProps);
        if (!formOptions)
            return;
        for (var i = 0; i < formOptions.length; i++) {
            var config = formOptions[i];
            this.setRequiredRefMapper(config);
        }
        // configArr.forEach(config => this.setRequiredRefMapper(config));
    };
    FormFilterHelper.prototype.setRequiredRefMapper = function (config) {
        if (!config || !config.required)
            return;
        var _a = this.wrapConditionTitle(config), _b = _a.title, title = _b === void 0 ? '' : _b, ref = _a.ref, refs = _a.refs, refu = _a.refu;
        switch (true) {
            case !!ref:
                this._requiredMapperSetter(ref, title);
                break;
            case !!refs:
                for (var _i = 0, refs_2 = refs; _i < refs_2.length; _i++) {
                    var _ref = refs_2[_i];
                    this._requiredMapperSetter(_ref, title);
                }
                break;
            case !!refu:
                for (var _ref in refu) {
                    this._requiredMapperSetter(_ref, title);
                }
                break;
        }
    };
    FormFilterHelper.prototype.setDefaultValues = function (options) {
        for (var i = 0; i < options.length; i++) {
            var config = options[i];
            if (config) {
                this.setDefaultValue(config);
                this.setRequiredRefMapper(config);
            }
        }
    };
    FormFilterHelper.prototype.setDefaultValue = function (config) {
        var _this = this;
        var defaultValue = config.defaultValue, ref = config.ref, refs = config.refs, range = config.range, refu = config.refu, refForS = config.refForS, defaultValueForS = config.defaultValueForS, type = config.type;
        if (HasValue(defaultValue)) {
            /** 观察这个地方，可能引起的内容不更新的问题 */
            if (ref)
                this.value[ref] = this.value[ref] || defaultValue;
            if (refForS)
                this.value[refForS] = this.value[refForS] || defaultValueForS;
            if (IsObj(refu)) {
                /** 判断是否有 defaultValueForS，如果有则直接使用，否则区 refu 第一个作为默认值 */
                var targetKey = void 0;
                if (HasValue(defaultValueForS)) {
                    targetKey = defaultValueForS;
                }
                else {
                    targetKey = Object.keys(refu)[0];
                }
                this.value[targetKey] = defaultValue;
            }
        }
        if (Array.isArray(range) && Array.isArray(refs)) {
            refs.forEach(function (_ref, idx) {
                _this.value[_ref] = range[idx];
            });
        }
        if (type === 'datetimeRange') {
            this.value[this.getRefsID(refs)] = range;
        }
    };
    FormFilterHelper.prototype.checkForm = function () {
        var requiredRefMapper = this.requiredRefMapper;
        var isPass = Object.keys(requiredRefMapper).length == 0;
        var desc = '';
        var ref = '';
        var requiredRefs = Object.keys(requiredRefMapper);
        var len = requiredRefs.length;
        for (var i = 0; i < len; i++) {
            var itemRef = requiredRefs[i];
            var currVal = this.value[itemRef];
            if (!HasValue(currVal)) {
                isPass = false;
                desc = requiredRefMapper[itemRef];
                ref = itemRef;
                this.focusRef(ref);
                break;
            }
            isPass = true;
        }
        var checkRes = {
            isPass: isPass,
            desc: desc,
            ref: ref
        };
        CallFunc(this.showDesc)(checkRes);
        return checkRes;
    };
    FormFilterHelper.prototype.wrapConditionTitle = function (config) {
        var title = config.title, tips = config.tips, ref = config.ref;
        config._title = this.$T(title) || this.$T(ref);
        if (tips) {
            config.tipsDOM = (React.createElement(ToolTip, { classNames: ['mr5'], title: tips, n: "question", s: "r" }));
        }
        return config;
    };
    FormFilterHelper.prototype.focusRef = function (ref) {
        var targetDOM = this._refs[ref];
        if (!!targetDOM && !!targetDOM.focus)
            targetDOM.focus();
    };
    /**
     * 改变单个值
     * @public
     * @param {any} value 目标改变的值的 value
     * @param {string} ref 改变的值的 ref
     * @param {boolean} update 是否更新视图
     */
    FormFilterHelper.prototype.changeValue = function (value, ref, update) {
        if (update === void 0) { update = true; }
        if (this.value[ref] === value)
            return;
        this.value[ref] = value;
        if (update) {
            this.setState({
                value: this.value
            });
        }
        Call(this.props.onChange, this.value, ref, value);
    };
    /**
     * 改变多个值
     * @public
     * @param {object} valRefMapper 改变的值的 object
     * @param {boolean} update 是否更新视图
     */
    FormFilterHelper.prototype.changeValues = function (valRefMapper, update) {
        var _this = this;
        if (update === void 0) { update = true; }
        var refs = Object.keys(valRefMapper);
        refs.forEach(function (ref) {
            var val = valRefMapper[ref];
            _this.changeValue(val, ref, update);
        });
    };
    FormFilterHelper.prototype.refreshCaptcha = function (ref) {
        this._refs[ref].refreshCaptcha();
    };
    FormFilterHelper.prototype.getValue = function (ref, otherwise) {
        var targetVal = this.value[ref];
        return HasValue(targetVal) ? targetVal : otherwise;
    };
    FormFilterHelper.prototype.greneratFormDOM = function (config) {
        var type = config.type;
        var generator = this.typeMapper[type];
        return generator && generator(config);
    };
    return FormFilterHelper;
}(UkeComponent));
export default FormFilterHelper;
