import React from 'react';
export interface IconProps {
    /** 是否使用默认的 icon 配置 */
    useIconConfig?: boolean;
    /** icon name */
    n?: string;
    /** icon style, 具体查看 https://fontawesome.com/ 的描述 */
    s?: 's' | 'r' | 'l' | 'b';
    /** icon name */
    type?: string;
    /** className for icon */
    className?: string;
    /** multiple class names, 例如 ['class1', 'class2'] */
    classNames?: string[];
    /** style */
    style?: React.CSSProperties;
    /** style */
    onClick?: (event?: React.MouseEvent<HTMLElement, MouseEvent>) => void;
}
declare const Icon: React.SFC<IconProps>;
declare const PureIcon: React.SFC<IconProps>;
export { PureIcon };
export default Icon;
