import { Component } from 'react';
import { Children, FuncChildren } from '../utils/props';
export interface LoadingProps {
    /** animation timeout */
    timeout?: number;
    /** loading 状态 */
    loading: boolean;
    /** animation className */
    animationClass?: string;
    /** 子内容，从 2.10.5 版本开始支持 function children */
    children?: FuncChildren | Children;
    /** 可以替换默认的 loading 模版 */
    loadingDOM?: any;
    /** 内容是否与 loading 模版共存 */
    inrow?: boolean;
}
export default class Loading extends Component<LoadingProps> {
    static defaultProps: {
        inrow: boolean;
        timeout: number;
        animationClass: string;
    };
    transitionWrap(key: any, children: any): JSX.Element;
    render(): JSX.Element;
}
