import React from 'react';
import { ModalOptions } from './modal';
import { Children } from '../utils/props';
declare function CloseModal(modalID: ModalID): void;
declare function CloseAllModal(): void;
export declare type ModalID = string | number;
export interface ShowModalParams extends ModalOptions {
    /** modalType */
    type?: ModalOptions['modalType'] | 'confirm';
    /** 当 type === confirm 时渲染的内容 */
    confirmText?: Children;
    /** 当 type === confirm 时，点击确认按钮的回调 */
    onConfirm?: any;
    /** 是否显示「确定、取消」按钮 */
    showFuncBtn?: boolean;
    /** 是否需要 header */
    needHeader?: boolean;
}
/**
 * @param {ShowModalParams} params
 */
declare function ShowModal(params: ShowModalParams): ModalID;
declare const ShowGlobalModal: typeof ShowModal;
declare const CloseGlobalModal: typeof CloseModal;
declare const ShowModalAPI: React.SFC<ShowModalParams>;
export { ShowModalAPI };
export { ShowModal, CloseModal, ShowGlobalModal, CloseGlobalModal, CloseAllModal };
