import React from 'react';
import { IconProps } from '../icon/icon';
import SelectorBasic, { SelectorValuesDescription, SelectorBasicProps } from './selector';
export interface RadioProps extends SelectorBasicProps, IconProps {
    values: SelectorValuesDescription;
    /** 是否需要多选按钮 */
    checkAllBtn?: boolean;
    /** 是否竖向排列 */
    column?: boolean;
    /** 传入每个 item 的 style */
    itemStyle?: React.CSSProperties;
    /** 统一控制每个 item 的宽度 */
    itemWidth?: string | number;
}
export default class Radio extends SelectorBasic<RadioProps> {
    static getDefaultValue(values: any): any;
    static defaultProps: {
        column: boolean;
    };
    selectItem(value: any, idx: any): void;
    render(): JSX.Element;
}
