import { PureComponent } from 'react';
export interface SwitchButtonProps {
    /** 按钮的配置 */
    btns: {
        [btnKey: string]: string;
    };
    /** 当前激活的 index */
    activeIdx: string | number;
    /** 值改变的回调 */
    onSwitch: (val: any, isActive: boolean) => void;
    /** 是否只有唯一值 */
    unique?: boolean;
    /** 是否输出数字 */
    isNum?: boolean;
    /** 是否禁用 */
    disabled?: boolean;
}
/**
 * 单选集合的模版
 *
 * @export
 * @class SwitchButton
 * @extends {PureComponent}
 */
export default class SwitchButton extends PureComponent<SwitchButtonProps> {
    static defaultProps: {
        unique: boolean;
        disabled: boolean;
        isNum: boolean;
    };
    value: any;
    _refs: {};
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
}
