export declare type PopoverPosition = 'top' | 'right' | 'left' | 'bottom';
export interface PositionReturn {
    position: PopoverPosition;
    top: number;
    left: number;
}
export interface GetFuncParams {
    /** 相对元素的属性 */
    offsetTop: number;
    /** 相对元素的属性 */
    offsetLeft: number;
    /** 相对元素的属性 */
    offsetWidth: number;
    /** 相对元素的属性 */
    offsetHeight: number;
    /** 当前需要定位的元素的属性 */
    elemWidth: number;
    /** 当前需要定位的元素的属性 */
    elemHeight: number;
    /** 内部属性 */
    verticalOffset?: number;
    /** 内部属性 */
    _fromInternal?: boolean;
}
/**
 * 计算最终的 top 和 left，并且根据浏览器可视边界判断最终结果
 */
export declare function getLeft(params: GetFuncParams): PositionReturn;
export declare function getRight(params: GetFuncParams): PositionReturn;
export declare function getTop(params: GetFuncParams): PositionReturn;
export declare function getBottom(params: GetFuncParams): PositionReturn;
