import { Component, PureComponent } from 'react';
import { getUkelliConfig, setUkelliConfig } from '../config';
/**
 * 用于提供所有 uke 组件的通用函数
 * 通过继承 UkeComponent 或者 UkePureComponent 获取通用函数
 */
export declare class UkeComponent<P = {}, S = {}, SS = any> extends Component<P, S, SS> {
    /** gm 将要弃用 */
    gm: (key: any) => string;
    /** 外部国际化键值对 $T() */
    $T: (key: any) => string;
    /** gmUke 将要弃用 */
    gmUke: (key: any) => string;
    /** uke 内部国际化键值对 $T_UKE() */
    $T_UKE: (key: any) => string;
    /** 获取 uke 内部配置 */
    getConfig: typeof getUkelliConfig;
    /** 设置 uke 内部配置 */
    setConfig: typeof setUkelliConfig;
}
export declare class UkePureComponent<P = {}, S = {}, SS = any> extends PureComponent<P, S, SS> {
    /** gm 将要弃用 */
    gm: (key: any) => string;
    /** 外部国际化键值对 $T() */
    $T: (key: any) => string;
    /** gmUke 将要弃用 */
    gmUke: (key: any) => string;
    /** uke 内部国际化键值对 $T_UKE() */
    $T_UKE: (key: any) => string;
    /** 获取 uke 内部配置 */
    getConfig: typeof getUkelliConfig;
    /** 设置 uke 内部配置 */
    setConfig: typeof setUkelliConfig;
}
